<template>
  <!-- Login form -->
  <form
    class="w-full"
    @submit="handleSubmit"
  >
    <!-- Error messages -->
    <!-- <t-alert
      v-if="form.globalError"
      :variant="$app.ui.isTheme({
        'light': 'white-smoke-error',
        'dark': 'dark-jungle-error'
      })"
      class="flex justify-center items-center mb-4"
      show
    >
      <div class="flex gap-4 items-center">
        <v-icon
          v-if="form.globalError?.errorCode === 'e0020' /* bad credentials */"
          name="lock"
          scale="1.7"
          class="@light:text-@light-error @dark:text-@dark-error"
        />
        <p>{{ form.globalError.message }}</p>
      </div>
    </t-alert> -->

    <!-- Password -->
    <InputPassword
      v-model="passwordValue"
      name="password"
      :variant="$app.ui.isTheme({
        'light': passwordState ? 'white-smoke-fluid' : 'white-smoke-error-fluid',
        'dark': passwordState ? 'dark-jungle-fluid' : 'dark-jungle-error-fluid'
      })"
      :state="passwordState"
      :placeholder="$t('auth.password') | capitalize"
      :label="$t('auth.password') | capitalize"
    />

    <!-- Confirm button -->
    <Button
      type="submit"
      variant="action"
      :disabled="!isFormValid"
      fluid
    >
      {{ $t('global.login') | capitalize }}
    </Button>
  </form>
</template>

<script>
import { utils } from '@hperchec/scorpion-ui'
// BaseForm
import BaseForm from '@/components/commons/form/base-form/BaseForm.vue'

const { isEmptyString } = utils

/**
 * Login component
 */
export default {
  name: 'Login',
  extends: BaseForm,
  // 'form' option (see src/components/commons/form/BaseForm)
  form: {
    fields: {
      /**
       * email
       */
      email: {
        // Default: generate 'emailValue' & 'emailChanged'
        default: function () {
          return ''
        },
        // Generate: 'isEmailValid'
        validator: function (value, fail) {
          if (isEmptyString(value)) fail('rule:Required')
          return true
        },
        // Will be called by valuesToData() method on data serializing
        dataFormatter: function (value) {
          return value.trim()
        }
      },
      /**
       * password
       */
      password: {
        // Default: generate 'passwordValue' & 'passwordChanged'
        default: function () {
          return ''
        },
        // Generate: 'isPasswordValid'
        validator: function (value, fail) {
          if (isEmptyString(value)) fail('rule:Required')
          return true
        }
      }
    }
  },
  methods: {
    /**
     * Handle click on 'confirm' submit button.
     * @param {object} event - The event payload
     * @returns {void}
     */
    handleSubmit (event) {
      // Prevent click
      event.preventDefault()
      event.stopPropagation()
      // Reset errors before
      this.resetErrors()
      // Log in
      this.login()
    },
    /**
     * Send request to the server and emit event at logged
     * @async
     * @returns {void}
     */
    async login () {
      // Get data from form values
      const data = this.valuesToData()
      // Send delete request to the server
      const requestResult = await this.$app.auth.login({ data })
      // If error
      if (requestResult instanceof Error) {
        // Set form errors from response
        this.setFormErrors(requestResult)
        // 401 => Bad credentials
        if (requestResult.response.status === 401) {
          // ...
        }
      } else {
        /**
         * Logged event
         */
        this.$emit('logged-in', requestResult)
      }
    }
  }
}
</script>
